# Creating WhatsApp Message templates

## Creating WhatsApp Message Templates

To create a WhatsApp approved message template via the API, follow these steps:

1. **Create a Project** -- a project houses the messaging template.
2. **Retrieve a Channel Group** -- templates are linked to a WABA (WhatsApp Business Account) via a channel group.
3. **Preview the Template** *(optional)* -- validate content and see a rendered preview before creating.
4. **Create a Channel Template** -- define the template content, variables, and deployments.
5. **Activate the Template** -- submit the template to Meta for approval.
6. **Check the Template Status** -- monitor approval status, quality rating, and platform-specific details.
7. **Update a Template** -- modify draft templates in-place or create new versions of active/inactive templates.

Once the template is approved by Meta, it can be used for sending messages by following the [Sending WhatsApp Messages](https://docs.bird.com/api/channels-api/supported-channels/programmable-whatsapp/sending-whatsapp-messages) guide.

{% hint style="info" %}
Before starting this guide, make sure you have [API Access](https://docs.bird.com/api/api-access) and are using the necessary Access Policies and Roles on your Access Key.
{% endhint %}

{% hint style="info" %}
**platformContent** defines the template structure using "blocks." The structure varies depending on the template type. See the [WhatsApp Template Blocks Reference](/api/touchpoints-api/supported-projects/whatsapp-approved-message-templates/creating-whatsapp-message-templates/whatsapp-template-blocks-reference.md) for all supported block types and examples.
{% endhint %}

***

### 1 -- Create a Project

Create a Message Template project where the WhatsApp template will be added.

## POST /workspaces/{workspaceId}/projects

> Create project

```json
{"openapi":"3.0.3","info":{"title":"Touchpoints","version":"v1"},"tags":[{"name":"projects","description":"Manage projects within a workspace"}],"servers":[{"url":"https://api.bird.com","description":"Production API"}],"security":[{"accessKey":[]}],"components":{"securitySchemes":{"accessKey":{"description":"Uses the Authorization header: 'AccessKey ' followed by your access key token (e.g., 'Authorization: AccessKey AbCdEfGhIjKlMnOpQrStUvWxYzAbCdEfGhIj')","scheme":"AccessKey","type":"http"}},"schemas":{"CreateProject":{"type":"object","additionalProperties":false,"required":["type"],"properties":{"name":{"type":"string"},"description":{"type":"string"},"type":{"$ref":"#/components/schemas/ProjectType"},"scope":{"$ref":"#/components/schemas/ProjectScope"},"suites":{"type":"array","items":{"$ref":"#/components/schemas/SuiteType"}},"tags":{"$ref":"#/components/schemas/Tags"},"directoryId":{"type":"string","format":"uuid","nullable":true},"experiment":{"$ref":"#/components/schemas/ProjectExperimentInput"}}},"ProjectType":{"type":"string","description":"enum for all the different project types Touchpoints API supports.","enum":["chatwidget","form","knowledgeBase","deepLink","channelTemplate","website","htmlEmail","popup","helpcenter","adCreative","preferencecenter","landingpage","inAppMessageTemplate"]},"ProjectScope":{"type":"number","enum":[0,1,2,3],"description":"dictionary:\n  * 0 DEFAULT: This should indicate that the project is of our current scope (can be used across all BirdCRM services).\n  * 1 SAVED_TEMPLATE: This should indicate that the project is a saved template, meaning that it came from extending one of BirdCRM library templates. They can be used for creating other Projects, such as inline campaigns and flows content.\n  * 2 INLINE_MESSAGE: This should indicate that the project is an inline message, meaning that it was created from a campaign or flow using a library template or a saved template. They are linked to an specific instance of other BirdCRM services (Campaigns, Flows, etc.).\n  * 3 (PLATFORM_REVIEWED_TEMPLATE): This should indicate that the project is a platform reviewed template, meaning the template must go through a external platform review.\n"},"SuiteType":{"type":"string","description":"The Suite indicates a Suite that an entity belongs to","enum":["marketing","service","payments","automations","developer"]},"Tags":{"type":"array","description":"Tags for this project","items":{"type":"string","minLength":1,"maxLength":36},"nullable":true},"ProjectExperimentInput":{"type":"object","nullable":true,"additionalProperties":false,"properties":{"status":{"$ref":"#/components/schemas/ProjectExperimentStatus"},"winningMetric":{"description":"The winning metric of the experiment. This can only be set when the experiment is in draft status.","$ref":"#/components/schemas/ProjectExperimentWinningMetric"},"weights":{"type":"object","description":"The weights of the experiment variants. These can only be changed when the experiment is in draft status.","additionalProperties":{"type":"integer","format":"int64"}},"duration":{"type":"integer","format":"int64","minimum":1440,"maximum":525600,"description":"An optional duration for the experiment in minutes. This can only be provided when the status is being changed to running."},"winningTemplateId":{"type":"string","format":"uuid","description":"The ID of the winning template."}}},"ProjectExperimentStatus":{"type":"string","description":"The status of the experiment.","enum":["draft","running","stopped","completed"]},"ProjectExperimentWinningMetric":{"type":"string","description":"The winning metric of the experiment.","enum":["openRate","readRate","clickRate","conversionRate"]},"Project":{"type":"object","additionalProperties":false,"required":["id","createdAt"],"properties":{"id":{"type":"string","format":"uuid"},"workspaceId":{"type":"string","format":"uuid"},"name":{"type":"string","minLength":0,"maxLength":100},"description":{"type":"string","minLength":0,"maxLength":300},"type":{"$ref":"#/components/schemas/ProjectType"},"scope":{"$ref":"#/components/schemas/ProjectScope"},"supportedPlatforms":{"$ref":"#/components/schemas/PlatformList"},"locales":{"type":"array","nullable":true,"items":{"$ref":"#/components/schemas/LocaleEnum"}},"localeStatuses":{"type":"object","nullable":true,"additionalProperties":{"type":"string","enum":["draft","pending","active","inactive"]}},"platformInfo":{"type":"object","nullable":true,"additionalProperties":{"$ref":"#/components/schemas/PlatformState"},"description":"Platform-specific state information for WhatsApp templates. The key is a string in the format \"platform:wabaId:locale\" (e.g., \"whatsapp:123456789:en\"). Contains status information for each WABA/Locale combination.\n"},"activeResourceId":{"type":"string","format":"uuid","nullable":true},"draftCount":{"type":"number"},"pendingCount":{"type":"number"},"activeCount":{"type":"number"},"inactiveCount":{"type":"number"},"createdAt":{"type":"string","format":"date-time"},"updatedAt":{"type":"string","nullable":true,"format":"date-time"},"approvedTemplateChannelsId":{"type":"array","nullable":true,"items":{"type":"string","format":"uuid"}},"approvedTemplateChannelGroupIds":{"type":"array","nullable":true,"items":{"type":"string","format":"uuid"}},"suites":{"type":"array","items":{"$ref":"#/components/schemas/SuiteType"}},"clonedFrom":{"type":"string","nullable":true,"format":"uuid","description":"The ID of the project that this project was cloned from. This field is only present if this project was cloned from another project.\n"},"metadata":{"$ref":"#/components/schemas/Metadata"},"tags":{"$ref":"#/components/schemas/Tags"},"directoryId":{"type":"string","format":"uuid","description":"The ID of the directory that this project belongs to. This field is only present if the project is part of a directory.\n"},"experiment":{"$ref":"#/components/schemas/ProjectExperiment"}}},"PlatformList":{"type":"array","nullable":true,"items":{"type":"string","enum":["all","apple-business-chat","sms-messagebird","facebook-messenger","google-business-messages","instagram","whatsapp","email-sparkpost","chat","push-notifications","rcs-google","linkedin","line","app-inbox","in-app-messages"]}},"LocaleEnum":{"type":"string","format":"locale-bcp47","enum":["ae-AZ","af","ar","ar-AZ","ar-EG","ar-ID","ar-UA","az","az-AZ","bg","bg-BG","bn","bn-MY","bn-SG","ca","cs","cs-CZ","da","da-DK","de","de-AT","de-CH","de-DE","de-LI","de-LU","ee-GH","el","el-CY","el-GR","en","en-AE","en-AF","en-AG","en-AL","en-AR","en-AS","en-AT","en-AU","en-AW","en-AZ","en-BA","en-BB","en-BD","en-BE","en-BF","en-BG","en-BH","en-BJ","en-BN","en-BO","en-BR","en-BS","en-BW","en-BY","en-BZ","en-CA","en-CD","en-CG","en-CH","en-CI","en-CL","en-CM","en-CN","en-CO","en-CY","en-CZ","en-DE","en-DK","en-DM","en-DO","en-EC","en-EG","en-ES","en-FI","en-FJ","en-FR","en-GB","en-GD","en-GE","en-GH","en-GI","en-GM","en-GR","en-GY","en-HK","en-HR","en-HT","en-HU","en-ID","en-IE","en-IL","en-IN","en-IQ","en-IS","en-IT","en-JM","en-JO","en-JP","en-KE","en-KH","en-KN","en-KR","en-KW","en-KY","en-KZ","en-LA","en-LB","en-LT","en-LV","en-MD","en-MK","en-MM","en-MS","en-MT","en-MV","en-MX","en-MY","en-NG","en-NL","en-NO","en-NP","en-NZ","en-OM","en-PA","en-PE","en-PG","en-PH","en-PK","en-PL","en-PS","en-PT","en-PY","en-QA","en-RO","en-RU","en-RW","en-SA","en-SB","en-SD","en-SE","en-SG","en-SI","en-SK","en-SN","en-SR","en-SS","en-TC","en-TH","en-TN","en-TO","en-TR","en-TT","en-TW","en-UG","en-US","en-UY","en-VC","en-VE","en-VG","en-VN","en-WS","en-YE","en-ZA","en-ZW","es","es-AR","es-BO","es-BR","es-CL","es-CO","es-CR","es-DO","es-EC","es-ES","es-GT","es-HN","es-MX","es-NI","es-PA","es-PE","es-PY","es-SV","es-US","es-UY","es-VE","et","et-EE","fa","fi","fi-FI","fil","fr","fr-AE","fr-BE","fr-BF","fr-BJ","fr-CA","fr-CD","fr-CG","fr-CH","fr-CI","fr-CM","fr-FR","fr-GA","fr-GF","fr-LU","fr-MA","fr-MF","fr-MG","fr-ML","fr-NL","fr-PT","fr-SN","fr-TG","ga","gu","ha","he","hi","hi-MY","hi-SG","hr","hr-HR","ht-DO","hu","hu-HU","id","id-HK","id-ID","id-JP","id-SG","it","it-AE","it-BE","it-CH","it-IT","ja","ja-JP","ka","kk","kn","ko","ky-KG","lo","lt","lt-LT","lv","lv-LV","mk","ml","mr","ms","ms-MY","my-JP","my-MY","my-SG","nb","ne-JP","nl","nl-BE","nl-NL","no-NO","pa","pl","pl-PL","pt","pt-AO","pt-BR","pt-PT","ro","ro-MD","ro-RO","ru","ru-BY","ru-KZ","ru-RO","ru-RU","rw-RW","sk","sk-SK","sl","sl-SI","sq","sq-AL","sr","sr-RS","sv","sv-SE","sw","ta","ta-MY","ta-SG","te","th","th-SG","th-TH","tk-TM","tr","tr-TR","uk","uk-UA","ur","uz","uz-UZ","vi","vi-JP","vi-MY","vi-US","zh-CN","zh-HK","zh-JP","zh-SG","zh-TW","zu"]},"PlatformState":{"type":"object","additionalProperties":false,"properties":{"status":{"type":"string","enum":["draft","active","inactive","pending","pendingReview"]},"category":{"type":"string"},"qualityRating":{"type":"string","default":"UNKNOWN","description":"Quality rating for WhatsApp templates (GREEN, YELLOW, RED, UNKNOWN)"}}},"Metadata":{"type":"array","items":{"type":"object","additionalProperties":false,"properties":{"key":{"type":"string"},"value":{"type":"string"}}}},"ProjectExperiment":{"type":"object","additionalProperties":false,"required":["status","winningMetric"],"properties":{"status":{"$ref":"#/components/schemas/ProjectExperimentStatus"},"winningMetric":{"$ref":"#/components/schemas/ProjectExperimentWinningMetric"},"weights":{"type":"object","description":"The weights of the experiment variants.","additionalProperties":{"type":"integer","format":"int64"}},"duration":{"type":"integer","format":"int64","description":"The duration of the experiment in minutes."},"startedAt":{"type":"string","format":"date-time","description":"The time when the experiment started."},"endedAt":{"type":"string","format":"date-time","description":"The time when the experiment ended."},"scheduledEndAt":{"type":"string","format":"date-time","description":"The scheduled end time of the experiment."},"weightsUpdatedAt":{"type":"string","format":"date-time","description":"The last time the weights were updated."},"winningTemplateId":{"type":"string","format":"uuid","description":"The ID of the winning template."},"stopperType":{"type":"string","description":"The type of caller who stopped the experiment."},"stopperId":{"type":"string","format":"uuid","description":"The reference to the caller who stopped the experiment."}}},"Error":{"type":"object","additionalProperties":false,"required":["code","message"],"properties":{"code":{"type":"string","minLength":5},"message":{"type":"string","minLength":5}}},"ValidationError":{"type":"object","additionalProperties":false,"required":["code","message"],"properties":{"code":{"type":"string","minLength":5},"message":{"type":"string","minLength":5},"details":{"type":"object","additionalProperties":{"type":"array","items":{"type":"string"}}}}}}},"paths":{"/workspaces/{workspaceId}/projects":{"post":{"summary":"Create project","operationId":"createProject","tags":["projects"],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/CreateProject"}}}},"responses":{"201":{"description":"Created","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Project"}}}},"404":{"description":"Workspace not found","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"409":{"description":"Duplicate project","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ValidationError"}}}},"422":{"description":"Invalid project","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ValidationError"}}}}}}}}}
```

**Example request:**

```json
{
  "type": "channelTemplate",
  "scope": 3,
  "name": "seasonal_promo",
  "description": "Marketing promotion template for WhatsApp",
  "suites": ["marketing"]
}
```

| Field    | Description                                                                                    |
| -------- | ---------------------------------------------------------------------------------------------- |
| `type`   | Must be `channelTemplate` for message templates                                                |
| `scope`  | Must be `3` (platform-reviewed template) -- Meta requires templates to be submitted for review |
| `name`   | A unique project name                                                                          |
| `suites` | The suite where this template will be used (e.g. `marketing`, `service`)                       |

**Example response:**

```json
{
  "id": "11323dfa-121f-4a4e-b4ef-35d325eaacb5",
  "name": "seasonal_promo",
  "description": "Marketing promotion template for WhatsApp",
  "type": "channelTemplate",
  "scope": 3,
  "supportedPlatforms": ["all"],
  "suites": ["marketing"],
  "draftCount": 0,
  "pendingCount": 0,
  "activeCount": 0,
  "inactiveCount": 0,
  "activeResourceId": null,
  "createdAt": "2025-09-19T17:19:04.087Z",
  "updatedAt": "2025-09-19T17:19:04.087Z"
}
```

Save the project `id` -- you will need it for the next steps.

***

### 2 -- Retrieve a Channel Group

Use the channel groups endpoint to find the channel group ID associated with your WABA. Templates are linked to a specific WABA through a channel group.

## GET /workspaces/{workspaceId}/projects/channel-templates/channel-groups

> Get enriched Channel groups for ChannelTemplate

```json
{"openapi":"3.0.3","info":{"title":"Touchpoints","version":"v1"},"tags":[],"servers":[{"url":"https://api.bird.com","description":"Production API"}],"security":[{"accessKey":[]}],"components":{"securitySchemes":{"accessKey":{"description":"Uses the Authorization header: 'AccessKey ' followed by your access key token (e.g., 'Authorization: AccessKey AbCdEfGhIjKlMnOpQrStUvWxYzAbCdEfGhIj')","scheme":"AccessKey","type":"http"}},"schemas":{"GetEnrichChannelGroups":{"type":"object","additionalProperties":false,"required":["results"],"properties":{"results":{"type":"array","items":{"$ref":"#/components/schemas/ChannelGroup"}}}},"ChannelGroup":{"type":"object","additionalProperties":false,"properties":{"id":{"type":"string","format":"uuid"},"platformGroupName":{"type":"string"},"platformGroupId":{"type":"string"},"platformId":{"type":"string","minLength":1},"channels":{"type":"array","items":{"$ref":"#/components/schemas/Channel"}},"createdAt":{"type":"string","format":"date-time"},"updatedAt":{"type":"string","format":"date-time"}}},"Channel":{"type":"object","additionalProperties":false,"properties":{"id":{"type":"string","format":"uuid"},"name":{"type":"string"},"identifier":{"type":"string"}}},"Error":{"type":"object","additionalProperties":false,"required":["code","message"],"properties":{"code":{"type":"string","minLength":5},"message":{"type":"string","minLength":5}}},"ValidationError":{"type":"object","additionalProperties":false,"required":["code","message"],"properties":{"code":{"type":"string","minLength":5},"message":{"type":"string","minLength":5},"details":{"type":"object","additionalProperties":{"type":"array","items":{"type":"string"}}}}}}},"paths":{"/workspaces/{workspaceId}/projects/channel-templates/channel-groups":{"get":{"summary":"Get enriched Channel groups for ChannelTemplate","operationId":"getEnrichChannelGroups","tags":["channeltemplates"],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/GetEnrichChannelGroups"}}}},"404":{"description":"Workspace not found","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"422":{"description":"Invalid request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ValidationError"}}}}}}}}}
```

**Example response:**

```json
{
  "results": [
    {
      "id": "3f979241-dea3-4f55-b7bb-d769eec27e51",
      "platformId": "whatsapp",
      "platformGroupId": "114128184961630",
      "platformGroupName": "Bird WABA",
      "channelIds": [
        "7b87eea0-631e-576d-a849-ecf58e837b6a"
      ],
      "createdAt": "2025-09-19T15:00:15.849Z",
      "updatedAt": "2025-09-19T15:00:15.849Z"
    }
  ]
}
```

| Field               | Description                                                                                             |
| ------------------- | ------------------------------------------------------------------------------------------------------- |
| `id`                | The channel group ID -- required for creating a template. Has a one-to-one relationship with your WABA. |
| `platformGroupId`   | Your WABA ID                                                                                            |
| `platformGroupName` | Your WABA name                                                                                          |
| `channelIds`        | List of WhatsApp channels associated with this WABA                                                     |

Save the channel group `id` -- you will need it when creating the template in step 4.

***

### 3 -- Preview the Template (Optional)

Before creating a template, you can use the preview endpoint to validate the content and resolve variables. This catches structural or validation errors early, before the template is submitted to Meta.

The preview endpoint returns JSON (not HTML). The response format depends on the template type:

* **Standard templates** (text, image, file/video): Returns `type: "body"` with the resolved Channels API message body structure -- the WhatsApp template payload with variables substituted.
* **Complex WhatsApp-specific templates** (carousel, catalog, multi-product, coupon, flow, etc.): Returns `type: "blocks"` with the blocks returned back, variables substituted, and styles applied.

In both cases, the response includes a `validationErrors` object that flags any issues.

## POST /workspaces/{workspaceId}/projects/channel-templates/create-preview

> Create ChannelTemplate Preview

```json
{"openapi":"3.0.3","info":{"title":"Touchpoints","version":"v1"},"tags":[],"servers":[{"url":"https://api.bird.com","description":"Production API"}],"security":[{"accessKey":[]}],"components":{"securitySchemes":{"accessKey":{"description":"Uses the Authorization header: 'AccessKey ' followed by your access key token (e.g., 'Authorization: AccessKey AbCdEfGhIjKlMnOpQrStUvWxYzAbCdEfGhIj')","scheme":"AccessKey","type":"http"}},"schemas":{"CreateChannelTemplatePreview":{"type":"object","additionalProperties":false,"properties":{"platform":{"type":"string","minLength":1},"blocks":{"type":"array","items":{"$ref":"#/components/schemas/block"}},"styles":{"type":"array","nullable":true,"items":{"$ref":"#/components/schemas/Style"}},"variables":{"type":"object","nullable":true,"additionalProperties":{"type":"string"}},"parameters":{"type":"array","nullable":true,"minLength":1,"items":{"$ref":"#/components/schemas/Parameter-2"}},"shortLinks":{"type":"object","nullable":true,"items":{"$ref":"#/components/schemas/ShortLinks"}},"contactId":{"type":"string","nullable":true},"locale":{"$ref":"#/components/schemas/LocaleBCP47","nullable":true}}},"block":{"type":"object","allOf":[{"type":"object","required":["type"],"properties":{"id":{"type":"string"},"reference":{"type":"string","nullable":true,"maxLength":100},"role":{"type":"string"},"hidden":{"type":"boolean"},"type":{"type":"string","enum":["action","carousel","list","file","html","image","location","text","layout","link-action","reply-action","authentication-body","authentication-action","apple-rich-link","apple-list-picker","apple-time-picker","apple-form","apple-apple-pay","apple-authentication","apple-quick-reply","apple-i-message","product","product-list","product-sections","multi-product-action","copy-code-action","call-phone-number-action","voice-call-action","open-catalog-action","limited-time-offer","whatsapp-catalog","whatsapp-product","whatsapp-product-list","whatsapp-coupon","whatsapp-multi-product","whatsapp-carousel","whatsapp-carousel-card","whatsapp-limited-time-offer","whatsapp-flow-action","whatsapp-product-item","whatsapp-flow","push-notifications-message","whatsapp-product-sections","whatsapp-product-section","rcs-basic-text","rcs-rich-card","rcs-carousel","rcs-rich-message","whatsapp-product-items","app-inbox-message"]}}},{"oneOf":[{"$ref":"#/components/schemas/action"},{"$ref":"#/components/schemas/carousel"},{"$ref":"#/components/schemas/list"},{"$ref":"#/components/schemas/file"},{"$ref":"#/components/schemas/html"},{"$ref":"#/components/schemas/image"},{"$ref":"#/components/schemas/location"},{"$ref":"#/components/schemas/text"},{"$ref":"#/components/schemas/layout"},{"$ref":"#/components/schemas/link_action"},{"$ref":"#/components/schemas/reply_action"},{"$ref":"#/components/schemas/authentication_body"},{"$ref":"#/components/schemas/authentication_action"},{"$ref":"#/components/schemas/apple_rich_link"},{"$ref":"#/components/schemas/apple_list_picker"},{"$ref":"#/components/schemas/apple_time_picker"},{"$ref":"#/components/schemas/apple_form"},{"$ref":"#/components/schemas/apple_apple_pay"},{"$ref":"#/components/schemas/apple_authentication"},{"$ref":"#/components/schemas/apple_quick_reply"},{"$ref":"#/components/schemas/apple_i_message"},{"$ref":"#/components/schemas/product"},{"$ref":"#/components/schemas/product_list"},{"$ref":"#/components/schemas/product_sections"},{"$ref":"#/components/schemas/multi_product_action"},{"$ref":"#/components/schemas/copy_code_action"},{"$ref":"#/components/schemas/call_phone_number_action"},{"$ref":"#/components/schemas/voice_call_action"},{"$ref":"#/components/schemas/open_catalog_action"},{"$ref":"#/components/schemas/limited_time_offer"},{"$ref":"#/components/schemas/whatsapp_catalog"},{"$ref":"#/components/schemas/whatsapp_product"},{"$ref":"#/components/schemas/whatsapp_product_list"},{"$ref":"#/components/schemas/whatsapp_coupon"},{"$ref":"#/components/schemas/whatsapp_multi_product"},{"$ref":"#/components/schemas/whatsapp_carousel"},{"$ref":"#/components/schemas/whatsapp_carousel_card"},{"$ref":"#/components/schemas/whatsapp_limited_time_offer"},{"$ref":"#/components/schemas/whatsapp_flow_action"},{"$ref":"#/components/schemas/whatsapp_product_item"},{"$ref":"#/components/schemas/whatsapp_flow"},{"$ref":"#/components/schemas/push_notification_message"},{"$ref":"#/components/schemas/whatsapp_product_sections"},{"$ref":"#/components/schemas/whatsapp_product_section"},{"$ref":"#/components/schemas/rcs_basic_text"},{"$ref":"#/components/schemas/rcs_rich_card"},{"$ref":"#/components/schemas/rcs_carousel"},{"$ref":"#/components/schemas/rcs_rich_message"},{"$ref":"#/components/schemas/whatsapp_product_items"},{"$ref":"#/components/schemas/app_inbox_message"}],"discriminator":{"propertyName":"type","mapping":{"action":"#/components/schemas/action","carousel":"#/components/schemas/carousel","list":"#/components/schemas/list","file":"#/components/schemas/file","html":"#/components/schemas/html","image":"#/components/schemas/image","location":"#/components/schemas/location","text":"#/components/schemas/text","layout":"#/components/schemas/layout","link-action":"#/components/schemas/link_action","reply-action":"#/components/schemas/reply_action","authentication-action":"#/components/schemas/authentication_action","authentication-body":"#/components/schemas/authentication_body","apple-rich-link":"#/components/schemas/apple_rich_link","apple-list-picker":"#/components/schemas/apple_list_picker","apple-time-picker":"#/components/schemas/apple_time_picker","apple-form":"#/components/schemas/apple_form","apple-apple-pay":"#/components/schemas/apple_apple_pay","apple-authentication":"#/components/schemas/apple_authentication","apple-quick-reply":"#/components/schemas/apple_quick_reply","apple-i-message":"#/components/schemas/apple_i_message","product":"#/components/schemas/product","product-list":"#/components/schemas/product_list","product-sections":"#/components/schemas/product_sections","multi-product-action":"#/components/schemas/multi_product_action","copy-code-action":"#/components/schemas/copy_code_action","call-phone-number-action":"#/components/schemas/call_phone_number_action","voice-call-action":"#/components/schemas/voice_call_action","open-catalog-action":"#/components/schemas/open_catalog_action","limited-time-offer":"#/components/schemas/limited_time_offer","whatsapp-catalog":"#/components/schemas/whatsapp_catalog","whatsapp-product":"#/components/schemas/whatsapp_product","whatsapp-product-list":"#/components/schemas/whatsapp_product_list","whatsapp-coupon":"#/components/schemas/whatsapp_coupon","whatsapp-multi-product":"#/components/schemas/whatsapp_multi_product","whatsapp-carousel":"#/components/schemas/whatsapp_carousel","whatsapp-carousel-card":"#/components/schemas/whatsapp_carousel_card","whatsapp-limited-time-offer":"#/components/schemas/whatsapp_limited_time_offer","whatsapp-flow-action":"#/components/schemas/whatsapp_flow_action","whatsapp-product-item":"#/components/schemas/whatsapp_product_item","whatsapp-flow":"#/components/schemas/whatsapp_flow","push-notifications-message":"#/components/schemas/push_notification_message","whatsapp-product-sections":"#/components/schemas/whatsapp_product_sections","whatsapp-product-section":"#/components/schemas/whatsapp_product_section","rcs-basic-text":"#/components/schemas/rcs_basic_text","rcs-rich-card":"#/components/schemas/rcs_rich_card","rcs-carousel":"#/components/schemas/rcs_carousel","rcs-rich-message":"#/components/schemas/rcs_rich_message","whatsapp-product-items":"#/components/schemas/whatsapp_product_items","app-inbox-message":"#/components/schemas/app_inbox_message"}}}]},"action":{"type":"object","nullable":true,"required":["type","action"],"properties":{"id":{"type":"string"},"type":{"type":"string","enum":["action"]},"reference":{"type":"string"},"role":{"type":"string"},"hidden":{"type":"boolean"},"action":{"allOf":[{"type":"object","required":["type"],"properties":{"type":{"type":"string","enum":["link","reply","locationRequest","buy","postback"]}}},{"oneOf":[{"$ref":"#/components/schemas/action_link"},{"$ref":"#/components/schemas/action_reply"},{"$ref":"#/components/schemas/action_location_request"},{"$ref":"#/components/schemas/action_buy"},{"$ref":"#/components/schemas/action_postback"}],"discriminator":{"propertyName":"type","mapping":{"link":"#/components/schemas/action_link","reply":"#/components/schemas/action_reply","locationRequest":"#/components/schemas/action_location_request","buy":"#/components/schemas/action_buy","postback":"#/components/schemas/action_postback"}}}]}}},"action_link":{"type":"object","required":["type","link"],"properties":{"id":{"type":"string"},"type":{"type":"string","enum":["link"]},"reference":{"type":"string"},"role":{"type":"string"},"hidden":{"type":"boolean"},"link":{"type":"object","required":["text","url"],"properties":{"text":{"type":"string"},"url":{"type":"string","format":"uri"}}}}},"action_reply":{"type":"object","required":["type","reply"],"properties":{"id":{"type":"string"},"type":{"type":"string","enum":["reply"]},"reference":{"type":"string"},"role":{"type":"string"},"hidden":{"type":"boolean"},"reply":{"type":"object","properties":{"text":{"type":"string"},"imageUrl":{"type":"string"}},"required":["text"]}}},"action_location_request":{"type":"object","required":["type","locationRequest"],"properties":{"id":{"type":"string"},"type":{"type":"string","enum":["locationRequest"]},"reference":{"type":"string"},"role":{"type":"string"},"hidden":{"type":"boolean"},"locationRequest":{"type":"object","properties":{"text":{"type":"string"}},"required":["text"]}}},"action_buy":{"type":"object","required":["type","buy"],"properties":{"id":{"type":"string"},"type":{"type":"string","enum":["buy"]},"reference":{"type":"string"},"role":{"type":"string"},"hidden":{"type":"boolean"},"buy":{"type":"object","properties":{"text":{"type":"string"},"amountCents":{"type":"integer"},"currency":{"type":"string","minLength":3,"maxLength":3}},"required":["text","amountCents","currency"]}}},"action_postback":{"type":"object","required":["type","postback"],"properties":{"id":{"type":"string"},"type":{"type":"string","enum":["postback"]},"reference":{"type":"string"},"role":{"type":"string"},"hidden":{"type":"boolean"},"postback":{"type":"object","properties":{"text":{"type":"string"},"payload":{"type":"string"}},"required":["text","payload"]}}},"carousel":{"type":"object","additionalProperties":false,"required":["type","carousel"],"properties":{"id":{"type":"string"},"type":{"type":"string","enum":["carousel"]},"reference":{"type":"string"},"role":{"type":"string"},"hidden":{"type":"boolean"},"carousel":{"type":"object","additionalProperties":false,"required":["items"],"properties":{"items":{"type":"array","nullable":false,"items":{"$ref":"#/components/schemas/item"}}}}}},"item":{"type":"object","additionalProperties":false,"required":["title"],"properties":{"id":{"type":"string"},"title":{"type":"string","minLength":1},"mediaUrl":{"type":"string","format":"uri","nullable":true},"description":{"type":"string"},"altText":{"type":"string"},"actions":{"type":"array","items":{"allOf":[{"type":"object","required":["type"],"properties":{"type":{"type":"string","enum":["link","reply","locationRequest","buy","postback"]}}},{"oneOf":[{"$ref":"#/components/schemas/action_link"},{"$ref":"#/components/schemas/action_reply"},{"$ref":"#/components/schemas/action_location_request"},{"$ref":"#/components/schemas/action_buy"},{"$ref":"#/components/schemas/action_postback"}],"discriminator":{"propertyName":"type","mapping":{"link":"#/components/schemas/action_link","reply":"#/components/schemas/action_reply","locationRequest":"#/components/schemas/action_location_request","buy":"#/components/schemas/action_buy","postback":"#/components/schemas/action_postback"}}}]}}}},"list":{"type":"object","additionalProperties":false,"required":["type","list"],"properties":{"id":{"type":"string"},"type":{"type":"string","enum":["list"]},"reference":{"type":"string"},"role":{"type":"string"},"hidden":{"type":"boolean"},"list":{"type":"object","additionalProperties":false,"required":["items"],"properties":{"title":{"type":"string"},"text":{"type":"string"},"altText":{"type":"string"},"items":{"type":"array","nullable":false,"items":{"$ref":"#/components/schemas/item"}},"actions":{"type":"array","items":{"allOf":[{"type":"object","required":["type"],"properties":{"type":{"type":"string","enum":["link","reply","locationRequest","buy","postback"]}}},{"oneOf":[{"$ref":"#/components/schemas/action_link"},{"$ref":"#/components/schemas/action_reply"},{"$ref":"#/components/schemas/action_location_request"},{"$ref":"#/components/schemas/action_buy"},{"$ref":"#/components/schemas/action_postback"}],"discriminator":{"propertyName":"type","mapping":{"link":"#/components/schemas/action_link","reply":"#/components/schemas/action_reply","locationRequest":"#/components/schemas/action_location_request","buy":"#/components/schemas/action_buy","postback":"#/components/schemas/action_postback"}}}]}}}}}},"file":{"type":"object","additionalProperties":false,"required":["type","file"],"properties":{"id":{"type":"string"},"type":{"type":"string","enum":["file"]},"reference":{"type":"string"},"role":{"type":"string"},"hidden":{"type":"boolean"},"file":{"type":"object","required":["mediaUrl","contentType"],"additionalProperties":false,"properties":{"mediaUrl":{"type":"string","format":"uri"},"contentType":{"type":"string"},"altText":{"type":"string"},"filename":{"type":"string"}}}}},"html":{"type":"object","additionalProperties":false,"required":["type","html"],"properties":{"id":{"type":"string"},"type":{"type":"string","enum":["html"]},"reference":{"type":"string"},"role":{"type":"string"},"hidden":{"type":"boolean"},"html":{"type":"string"}}},"image":{"type":"object","additionalProperties":false,"required":["type","image"],"properties":{"id":{"type":"string"},"type":{"type":"string","enum":["image"]},"reference":{"type":"string"},"role":{"type":"string"},"hidden":{"type":"boolean"},"image":{"type":"object","required":["mediaUrl"],"additionalProperties":false,"properties":{"mediaUrl":{"type":"string","format":"uri"},"altText":{"type":"string","description":"altText with image headers is not supported. If passed, it will default to a footer instead"}}}}},"location":{"type":"object","additionalProperties":false,"required":["type","location"],"properties":{"id":{"type":"string"},"type":{"type":"string","enum":["location"]},"reference":{"type":"string"},"role":{"type":"string"},"hidden":{"type":"boolean"},"location":{"type":"object","additionalProperties":false,"required":["coordinates"],"properties":{"coordinates":{"type":"object","additionalProperties":false,"properties":{"latitude":{"type":"number","format":"float","minimum":-90,"maximum":90},"longitude":{"type":"number","format":"float","minimum":-180,"maximum":180}}},"location":{"type":"object","additionalProperties":false,"properties":{"address":{"type":"string"},"label":{"type":"string"}}}}}}},"text":{"type":"object","additionalProperties":false,"required":["type","text"],"properties":{"id":{"type":"string"},"type":{"type":"string","enum":["text"]},"reference":{"type":"string"},"role":{"type":"string"},"hidden":{"type":"boolean"},"text":{"type":"object","additionalProperties":false,"required":["text"],"properties":{"text":{"type":"string"}}}}},"layout":{"type":"object","additionalProperties":false,"required":["type","layout"],"properties":{"id":{"type":"string"},"type":{"type":"string","enum":["layout"]},"reference":{"type":"string"},"role":{"type":"string"},"hidden":{"type":"boolean"},"layout":{"type":"object","additionalProperties":false,"required":["layout","blocks"],"properties":{"layout":{"type":"string","enum":["left","center","right"]},"blocks":{"type":"array","minItems":1,"maxItems":4,"items":{"anyOf":[{"$ref":"#/components/schemas/action"},{"$ref":"#/components/schemas/image"},{"$ref":"#/components/schemas/text"}]}}}}}},"link_action":{"type":"object","required":["type","linkAction"],"properties":{"id":{"type":"string"},"type":{"type":"string","enum":["link-action"]},"reference":{"type":"string"},"role":{"type":"string"},"hidden":{"type":"boolean"},"linkAction":{"type":"object","required":["text","url"],"properties":{"text":{"type":"string"},"url":{"anyOf":[{"type":"string","pattern":"{{[^{}]+}}"},{"type":"string","format":"uri"}]}}}}},"reply_action":{"type":"object","required":["type","replyAction"],"properties":{"id":{"type":"string"},"type":{"type":"string","enum":["reply-action"]},"reference":{"type":"string"},"role":{"type":"string"},"hidden":{"type":"boolean"},"replyAction":{"type":"object","properties":{"text":{"type":"string"},"imageUrl":{"type":"string"},"payload":{"type":"string"}},"required":["text"]}}},"authentication_body":{"type":"object","additionalProperties":false,"required":["type","authenticationBody"],"description":"An authentication body block used for authentication templates.","properties":{"id":{"type":"string"},"type":{"type":"string","enum":["authentication-body"]},"reference":{"type":"string"},"role":{"type":"string"},"hidden":{"type":"boolean"},"authenticationBody":{"type":"object","additionalProperties":false,"required":["addSecurityDisclaimer"],"properties":{"addSecurityDisclaimer":{"type":"boolean","description":"Whether to add a security disclaimer to the authentication body.","nullable":false},"expirationTime":{"type":"integer","minimum":1,"maximum":90,"nullable":true,"description":"The number of seconds after which the authentication body will expire. If not set, no expiration notification will be sent."},"messageSendTtlSeconds":{"type":"integer","minimum":1,"maximum":86400,"nullable":true,"description":"The number of seconds after which the message will expire. If not set, the message will not expire."}}}}},"authentication_action":{"type":"object","additionalProperties":false,"required":["type"],"description":"An authentication action block used for authentication templates.","properties":{"id":{"type":"string"},"type":{"type":"string","enum":["authentication-action"]},"reference":{"type":"string"},"role":{"type":"string"},"hidden":{"type":"boolean"},"authenticationAction":{"type":"object","additionalProperties":false,"properties":{"oneTap":{"type":"object","nullable":true,"additionalProperties":false,"required":["androidPackageName","androidSignatureHash"],"description":"The one-tap configuration for the authentication action used on Android devices. For iOS a fallback to the standard authentication action will be used. If set to `null`, the standard authentication action will be used.\n","properties":{"androidPackageName":{"type":"string","nullable":false,"description":"The Android package name of the app that will be used for one-tap authentication.\n"},"androidSignatureHash":{"type":"string","nullable":false,"description":"The Android signature hash of the app that will be used for one-tap authentication.\n"}}},"zeroTap":{"type":"object","nullable":true,"additionalProperties":false,"required":["supportedApps"],"description":"The zero-tap configuration for the authentication action used on Android devices. For iOS a fallback to the standard authentication action will be used. If set to `null`, the standard authentication action will be used.\n","properties":{"supportedApps":{"type":"array","items":{"$ref":"#/components/schemas/whatsapp_supported_app"}},"zeroTapTermsAccepted":{"type":"boolean","nullable":false,"description":"Indicates if the user has accepted the terms and conditions for zero-tap authentication.\n"}}}}}}},"whatsapp_supported_app":{"type":"object","additionalProperties":false,"required":["packageName","signatureHash"],"properties":{"packageName":{"type":"string","nullable":false,"description":"The package name of the app that will be used for authentication.\n"},"signatureHash":{"type":"string","nullable":false,"description":"The signature hash of the app that will be used for authentication.\n"}}},"apple_rich_link":{"type":"object","additionalProperties":false,"required":["type","appleRichLink"],"description":"An apple rich link block.","properties":{"id":{"type":"string"},"type":{"type":"string","enum":["apple-rich-link"]},"reference":{"type":"string"},"role":{"type":"string"},"hidden":{"type":"boolean"},"appleRichLink":{"type":"object","additionalProperties":false,"required":["url","title"],"properties":{"url":{"type":"string","nullable":false,"format":"uri"},"title":{"type":"string","nullable":true},"videoUrl":{"type":"string","nullable":true,"format":"uri"},"imageUrl":{"type":"string","nullable":true,"format":"uri"}}}}},"apple_list_picker":{"type":"object","additionalProperties":false,"required":["type","appleListPicker"],"properties":{"id":{"type":"string"},"type":{"type":"string","enum":["apple-list-picker"]},"reference":{"type":"string"},"role":{"type":"string"},"hidden":{"type":"boolean"},"appleListPicker":{"type":"object","additionalProperties":false,"required":["receivedMessage","replyMessage","sectionList"],"properties":{"receivedMessage":{"$ref":"#/components/schemas/apple_display_message"},"replyMessage":{"$ref":"#/components/schemas/apple_display_message"},"sectionList":{"$ref":"#/components/schemas/section_list"}}}}},"apple_display_message":{"type":"object","additionalProperties":false,"required":["title"],"properties":{"title":{"type":"string","minLength":1},"subtitle":{"type":"string"},"secondaryTitle":{"type":"string"},"tertiaryTitle":{"type":"string"},"imageUrl":{"type":"string","nullable":true},"imageTitle":{"type":"string"},"imageSubtitle":{"type":"string"},"style":{"type":"string","enum":["icon","small","large"]}}},"section_list":{"type":"object","required":["type"],"additionalProperties":false,"properties":{"type":{"type":"string","enum":["static","dynamic"]},"parameterKey":{"type":"string","pattern":"^\\{\\{.+\\}\\}$"},"sections":{"$ref":"#/components/schemas/sections"}}},"sections":{"type":"array","nullable":true,"items":{"type":"object","additionalProperties":false,"required":["title","items"],"properties":{"id":{"type":"string","nullable":true},"multipleSelection":{"type":"boolean"},"title":{"type":"string"},"items":{"type":"array","items":{"$ref":"#/components/schemas/reply_action"}}}}},"apple_time_picker":{"type":"object","additionalProperties":false,"required":["type","appleTimePicker"],"properties":{"id":{"type":"string"},"type":{"type":"string","enum":["apple-time-picker"]},"reference":{"type":"string"},"role":{"type":"string"},"hidden":{"type":"boolean"},"appleTimePicker":{"type":"object","additionalProperties":false,"required":["receivedMessage","replyMessage","timeslotList"],"properties":{"receivedMessage":{"$ref":"#/components/schemas/apple_display_message"},"replyMessage":{"$ref":"#/components/schemas/apple_display_message"},"timeslotList":{"$ref":"#/components/schemas/timeslot_list"},"location":{"type":"object","additionalProperties":false,"required":["coordinates"],"properties":{"coordinates":{"type":"object","additionalProperties":false,"properties":{"latitude":{"type":"number","format":"float","minimum":-90,"maximum":90},"longitude":{"type":"number","format":"float","minimum":-180,"maximum":180}}},"location":{"type":"object","additionalProperties":false,"properties":{"address":{"type":"string"},"label":{"type":"string"}}}}},"timezoneOffset":{"type":"string","pattern":"^[A-Za-z]+/[A-Za-z_]+$"}}}}},"timeslot_list":{"type":"object","required":["type"],"additionalProperties":false,"properties":{"type":{"type":"string","enum":["static","dynamic"]},"parameterKey":{"type":"string","pattern":"^\\{\\{.+\\}\\}$"},"timeslots":{"$ref":"#/components/schemas/timeslots"}}},"timeslots":{"type":"array","nullable":true,"items":{"type":"object","additionalProperties":false,"required":["startTime","duration"],"properties":{"id":{"type":"string","nullable":true},"startTime":{"type":"string","format":"date-time"},"duration":{"type":"number"}}}},"apple_form":{"type":"object","additionalProperties":false,"required":["type","appleForm"],"properties":{"id":{"type":"string"},"type":{"type":"string","enum":["apple-form"]},"reference":{"type":"string"},"role":{"type":"string"},"hidden":{"type":"boolean"},"appleForm":{"type":"object","additionalProperties":false,"required":["receivedMessage","replyMessage","data"],"properties":{"receivedMessage":{"$ref":"#/components/schemas/apple_display_message"},"replyMessage":{"$ref":"#/components/schemas/apple_display_message"},"data":{"type":"object","additionalProperties":false,"required":["splash","pages"],"properties":{"startPageIdentifier":{"type":"string"},"showSummary":{"type":"boolean"},"splash":{"type":"object","additionalProperties":false,"required":["header","splashText","buttonTitle"],"properties":{"header":{"type":"string"},"splashText":{"type":"string"},"buttonTitle":{"type":"string"},"imageUrl":{"type":"string"}}},"pages":{"type":"array","items":{"type":"object","additionalProperties":false,"required":["pageIdentifier","type"],"properties":{"pageIdentifier":{"type":"string"},"title":{"type":"string"},"subtitle":{"type":"string"},"hintText":{"type":"string"},"pickerTitle":{"type":"string"},"type":{"type":"string"},"multipleSelection":{"type":"boolean"},"nextPageIdentifier":{"type":"string"},"items":{"type":"array","items":{"type":"object","additionalProperties":false,"required":["identifier","title","value"],"properties":{"identifier":{"type":"string"},"title":{"type":"string"},"value":{"type":"string"},"imageUrl":{"type":"string"},"nextPageIdentifier":{"type":"string"}}}},"options":{"type":"object","additionalProperties":false,"properties":{"required":{"type":"boolean"},"inputType":{"type":"string"},"maximumCharacterCount":{"oneOf":[{"type":"string","pattern":"^\\{\\{.+\\}\\}$"},{"type":"string","pattern":"^[0-9]+$"},{"type":"string","pattern":"^$"}]},"keyboardType":{"type":"string"},"startDate":{"type":"string"},"maximumDate":{"type":"string"},"minimumDate":{"type":"string"},"dateFormat":{"type":"string"}}},"submitForm":{"type":"boolean"},"itemsListingType":{"type":"string","enum":["static","dynamic"]},"itemsParameterKey":{"type":"string","pattern":"^\\{\\{.+\\}\\}$"}}}}}}}}}},"apple_apple_pay":{"type":"object","additionalProperties":false,"required":["type","appleApplePay"],"properties":{"id":{"type":"string"},"type":{"type":"string","enum":["apple-apple-pay"]},"reference":{"type":"string"},"role":{"type":"string"},"hidden":{"type":"boolean"},"appleApplePay":{"type":"object","additionalProperties":false,"required":["receivedMessage","lineItemList","totalCost","currencyCode"],"properties":{"receivedMessage":{"$ref":"#/components/schemas/apple_display_message"},"replyMessage":{"$ref":"#/components/schemas/apple_display_message"},"lineItemList":{"$ref":"#/components/schemas/apple_line_item_list"},"totalCost":{"type":"object","additionalProperties":false,"properties":{"amount":{"type":"string"},"text":{"type":"string"},"type":{"nullable":true,"type":"string","enum":["pending","final"]}}},"shippingMethodList":{"$ref":"#/components/schemas/apple_shipping_method_list"},"currencyCode":{"type":"string"},"requiredBillingContactFields":{"type":"array","items":{"type":"string","enum":["postalAddress","name","email","phone","phoneticName"]}},"requiredShippingContactFields":{"type":"array","items":{"type":"string","enum":["postalAddress","name","email","phone","phoneticName"]}}}}}},"apple_line_item_list":{"oneOf":[{"type":"object","required":["type","lineItems"],"additionalProperties":false,"properties":{"type":{"type":"string","enum":["static","dynamic"]},"parameterKey":{"type":"string"},"lineItems":{"type":"array","items":{"$ref":"#/components/schemas/apple_line_item"}}}},{"type":"object","required":["type","parameterKey"],"additionalProperties":false,"properties":{"type":{"type":"string","enum":["dynamic"]},"parameterKey":{"type":"string"}}}]},"apple_line_item":{"type":"object","additionalProperties":false,"required":["amount","text"],"properties":{"id":{"type":"string","nullable":true},"amount":{"type":"string"},"text":{"type":"string"},"type":{"type":"string","enum":["pending","final"]}}},"apple_shipping_method_list":{"type":"object","required":["type"],"nullable":true,"additionalProperties":false,"properties":{"type":{"type":"string","enum":["static","dynamic"]},"parameterKey":{"type":"string"},"shippingMethods":{"$ref":"#/components/schemas/apple_shipping_methods"}}},"apple_shipping_methods":{"type":"array","nullable":true,"items":{"type":"object","additionalProperties":false,"required":["amount","label","identifier","detail"],"properties":{"amount":{"type":"string"},"label":{"type":"string"},"identifier":{"type":"string"},"detail":{"type":"string"}}}},"apple_authentication":{"type":"object","additionalProperties":false,"required":["type","appleAuthentication"],"properties":{"id":{"type":"string"},"type":{"type":"string","enum":["apple-authentication"]},"reference":{"type":"string"},"role":{"type":"string"},"hidden":{"type":"boolean"},"appleAuthentication":{"type":"object","additionalProperties":false,"required":["receivedMessage","replyMessage"],"properties":{"receivedMessage":{"$ref":"#/components/schemas/apple_display_message"},"replyMessage":{"$ref":"#/components/schemas/apple_display_message"}}}}},"apple_quick_reply":{"type":"object","additionalProperties":false,"required":["type","appleQuickReply"],"properties":{"id":{"type":"string"},"type":{"type":"string","enum":["apple-quick-reply"]},"reference":{"type":"string"},"role":{"type":"string"},"hidden":{"type":"boolean"},"appleQuickReply":{"type":"object","additionalProperties":false,"required":["summary","items"],"properties":{"summary":{"type":"string"},"items":{"type":"array","minItems":1,"maxItems":5,"items":{"type":"object","additionalProperties":false,"required":["identifier","title"],"properties":{"identifier":{"type":"string"},"title":{"type":"string"}}}}}}}},"apple_i_message":{"type":"object","additionalProperties":false,"required":["type","appleIMessage"],"properties":{"id":{"type":"string"},"type":{"type":"string","enum":["apple-i-message"]},"reference":{"type":"string"},"role":{"type":"string"},"hidden":{"type":"boolean"},"appleIMessage":{"type":"object","additionalProperties":false,"required":["appId","appName","receivedMessage","url","bid","useLiveLayout"],"properties":{"appId":{"type":"string"},"appName":{"type":"string"},"receivedMessage":{"$ref":"#/components/schemas/apple_display_message"},"url":{"type":"string"},"useLiveLayout":{"type":"boolean"},"bid":{"type":"string"}}}}},"product":{"type":"object","additionalProperties":false,"required":["type","product"],"description":"A product block used for commerce product templates.","properties":{"id":{"type":"string"},"type":{"type":"string","enum":["product"]},"reference":{"type":"string"},"role":{"type":"string"},"hidden":{"type":"boolean"},"product":{"type":"object","additionalProperties":false,"properties":{"externalProductId":{"type":"string"},"amount":{"type":"string"},"text":{"type":"string"},"type":{"type":"string","enum":["pending","final"]}}}}},"product_list":{"type":"object","additionalProperties":false,"required":["id","type","productList"],"description":"A product list block used for commerce product listing templates.","properties":{"id":{"type":"string"},"type":{"type":"string","enum":["product-list"]},"reference":{"type":"string"},"role":{"type":"string"},"hidden":{"type":"boolean"},"productList":{"$ref":"#/components/schemas/product_list_object"}}},"product_list_object":{"oneOf":[{"type":"object","required":["type","products"],"additionalProperties":false,"properties":{"type":{"type":"string","enum":["static","dynamic"]},"parameterKey":{"type":"string"},"products":{"type":"array","items":{"$ref":"#/components/schemas/product"}}}},{"type":"object","required":["type","parameterKey"],"additionalProperties":false,"properties":{"type":{"type":"string","enum":["dynamic"]},"parameterKey":{"type":"string"}}}]},"product_sections":{"type":"object","additionalProperties":false,"required":["type","productSections"],"description":"A product sectioned list block used for commerce product sectioned listing templates.","properties":{"id":{"type":"string"},"type":{"type":"string","enum":["product-sections"]},"reference":{"type":"string"},"role":{"type":"string"},"hidden":{"type":"boolean"},"productSections":{"oneOf":[{"type":"object","additionalProperties":false,"required":["type","sections"],"properties":{"type":{"type":"string","enum":["static"]},"sections":{"$ref":"#/components/schemas/product_sections_object"}}},{"type":"object","additionalProperties":false,"required":["type","parameterKey"],"properties":{"type":{"type":"string","enum":["dynamic"]},"parameterKey":{"type":"string"}}}]}}},"product_sections_object":{"type":"array","nullable":true,"items":{"type":"object","additionalProperties":false,"required":["title","products"],"properties":{"title":{"type":"string"},"products":{"type":"array","items":{"$ref":"#/components/schemas/product_object"}}}}},"product_object":{"type":"object","additionalProperties":false,"properties":{"externalProductId":{"type":"string","nullable":false}},"required":["externalProductId"]},"multi_product_action":{"type":"object","additionalProperties":false,"required":["type","multiProductAction"],"properties":{"id":{"type":"string"},"type":{"type":"string","enum":["multi-product-action"]},"reference":{"type":"string"},"role":{"type":"string"},"hidden":{"type":"boolean"},"multiProductAction":{"type":"object","additionalProperties":false,"required":["parameterKey"],"properties":{"parameterKey":{"type":"string"},"thumbnailExternalProductId":{"type":"string"},"productSections":{"type":"array","items":{"$ref":"#/components/schemas/whatsapp_product_section"}},"productList":{"type":"array","items":{"$ref":"#/components/schemas/whatsapp_product_item"}}}}}},"whatsapp_product_section":{"type":"object","additionalProperties":false,"required":["type","whatsappProductSection"],"description":"A WhatsApp specific product section block used for grouping products in WhatsApp.","properties":{"id":{"type":"string"},"type":{"type":"string","enum":["whatsapp-product-section"]},"reference":{"type":"string"},"role":{"type":"string"},"hidden":{"type":"boolean"},"whatsappProductSection":{"type":"object","additionalProperties":false,"required":["title","products"],"properties":{"title":{"type":"string"},"products":{"type":"array","items":{"$ref":"#/components/schemas/whatsapp_product_item"}}}}}},"whatsapp_product_item":{"type":"object","additionalProperties":false,"required":["type","whatsappProductItem"],"description":"A product block used for WhatsApp product.","properties":{"id":{"type":"string"},"type":{"type":"string","enum":["whatsapp-product-item"]},"reference":{"type":"string"},"role":{"type":"string"},"hidden":{"type":"boolean"},"whatsappProductItem":{"type":"object","additionalProperties":false,"required":["externalProductId"],"properties":{"externalProductId":{"type":"string"}}}}},"copy_code_action":{"type":"object","additionalProperties":false,"required":["type","copyCodeAction"],"properties":{"id":{"type":"string"},"type":{"type":"string","enum":["copy-code-action"]},"reference":{"type":"string"},"role":{"type":"string"},"hidden":{"type":"boolean"},"copyCodeAction":{"type":"object","additionalProperties":false,"required":["code"],"properties":{"code":{"type":"string"}}}}},"call_phone_number_action":{"type":"object","additionalProperties":false,"required":["type","callPhoneNumberAction"],"properties":{"id":{"type":"string"},"type":{"type":"string","enum":["call-phone-number-action"]},"reference":{"type":"string"},"role":{"type":"string"},"hidden":{"type":"boolean"},"callPhoneNumberAction":{"type":"object","additionalProperties":false,"required":["text","phoneNumber"],"properties":{"text":{"type":"string","maxLength":25,"minLength":1},"phoneNumber":{"type":"string","maxLength":20,"minLength":1}}}}},"voice_call_action":{"type":"object","additionalProperties":false,"required":["type","voiceCallAction"],"properties":{"id":{"type":"string"},"type":{"type":"string","enum":["voice-call-action"]},"reference":{"type":"string"},"role":{"type":"string"},"hidden":{"type":"boolean"},"voiceCallAction":{"type":"object","additionalProperties":false,"required":["text"],"properties":{"text":{"type":"string","maxLength":25,"minLength":1}}}}},"open_catalog_action":{"type":"object","additionalProperties":false,"required":["type","openCatalogAction"],"properties":{"id":{"type":"string"},"type":{"type":"string","enum":["open-catalog-action"]},"reference":{"type":"string"},"role":{"type":"string"},"hidden":{"type":"boolean"},"openCatalogAction":{"type":"object","additionalProperties":false,"properties":{"thumbnail":{"type":"object","additionalProperties":false,"required":["externalProductId"],"properties":{"externalProductId":{"type":"string"}}}}}}},"limited_time_offer":{"type":"object","additionalProperties":false,"required":["type","limitedTimeOffer"],"properties":{"id":{"type":"string"},"type":{"type":"string","enum":["limited-time-offer"]},"reference":{"type":"string"},"role":{"type":"string"},"hidden":{"type":"boolean"},"limitedTimeOffer":{"type":"object","additionalProperties":false,"required":["text"],"properties":{"text":{"type":"string"},"expiresAt":{"type":"string","nullable":true}}}}},"whatsapp_catalog":{"type":"object","additionalProperties":false,"required":["type","whatsappCatalog"],"properties":{"id":{"type":"string"},"type":{"type":"string","enum":["whatsapp-catalog"]},"reference":{"type":"string"},"role":{"type":"string"},"hidden":{"type":"boolean"},"whatsappCatalog":{"type":"object","additionalProperties":false,"required":["body","action"],"properties":{"body":{"$ref":"#/components/schemas/text"},"action":{"$ref":"#/components/schemas/open_catalog_action"},"footer":{"$ref":"#/components/schemas/text"}}}}},"whatsapp_product":{"type":"object","additionalProperties":false,"required":["type","whatsappProduct"],"description":"A product block used for commerce product templates.","properties":{"id":{"type":"string"},"type":{"type":"string","enum":["whatsapp-product"]},"reference":{"type":"string"},"role":{"type":"string"},"hidden":{"type":"boolean"},"whatsappProduct":{"type":"object","additionalProperties":false,"properties":{"body":{"$ref":"#/components/schemas/text"},"product":{"$ref":"#/components/schemas/whatsapp_product_item"},"footer":{"$ref":"#/components/schemas/text"}}}}},"whatsapp_product_list":{"type":"object","additionalProperties":false,"required":["type","whatsappProductList"],"description":"A product list block used for commerce product templates.","properties":{"id":{"type":"string"},"type":{"type":"string","enum":["whatsapp-product-list"]},"reference":{"type":"string"},"role":{"type":"string"},"hidden":{"type":"boolean"},"whatsappProductList":{"type":"object","additionalProperties":false,"required":["header","body","products"],"properties":{"header":{"$ref":"#/components/schemas/text"},"body":{"$ref":"#/components/schemas/text"},"products":{"oneOf":[{"$ref":"#/components/schemas/whatsapp_product_items"},{"$ref":"#/components/schemas/whatsapp_product_sections"}]},"footer":{"$ref":"#/components/schemas/text"}}}}},"whatsapp_product_items":{"type":"object","additionalProperties":false,"required":["type","whatsappProductItems"],"description":"A list of WhatsApp products.","properties":{"id":{"type":"string"},"type":{"type":"string","enum":["whatsapp-product-items"]},"reference":{"type":"string"},"role":{"type":"string"},"hidden":{"type":"boolean"},"whatsappProductItems":{"oneOf":[{"type":"object","required":["type","products"],"additionalProperties":false,"properties":{"type":{"type":"string","enum":["static"]},"parameterKey":{"type":"string"},"products":{"type":"array","items":{"$ref":"#/components/schemas/whatsapp_product_item"}}}},{"type":"object","required":["type","parameterKey"],"additionalProperties":false,"properties":{"type":{"type":"string","enum":["dynamic"]},"parameterKey":{"type":"string"}}}]}}},"whatsapp_product_sections":{"type":"object","additionalProperties":false,"required":["type","whatsappProductSections"],"description":"A WhatsApp specific product sectioned list block used for showing products in WhatsApp.","properties":{"id":{"type":"string"},"type":{"type":"string","enum":["whatsapp-product-sections"]},"reference":{"type":"string"},"role":{"type":"string"},"hidden":{"type":"boolean"},"whatsappProductSections":{"oneOf":[{"type":"object","additionalProperties":false,"required":["type","sections"],"properties":{"type":{"type":"string","enum":["static"]},"sections":{"type":"array","items":{"$ref":"#/components/schemas/whatsapp_product_section"}}}},{"type":"object","additionalProperties":false,"required":["type","parameterKey"],"properties":{"type":{"type":"string","enum":["dynamic"]},"parameterKey":{"type":"string"}}}]}}},"whatsapp_coupon":{"type":"object","additionalProperties":false,"required":["type","whatsappCoupon"],"properties":{"id":{"type":"string"},"type":{"type":"string","enum":["whatsapp-coupon"]},"reference":{"type":"string"},"role":{"type":"string"},"hidden":{"type":"boolean"},"whatsappCoupon":{"type":"object","additionalProperties":false,"required":["body","couponAction"],"properties":{"header":{"oneOf":[{"$ref":"#/components/schemas/text"},{"$ref":"#/components/schemas/image"},{"$ref":"#/components/schemas/file"}]},"body":{"$ref":"#/components/schemas/text"},"footer":{"$ref":"#/components/schemas/text"},"couponAction":{"$ref":"#/components/schemas/copy_code_action"},"actions":{"type":"array","items":{"anyOf":[{"$ref":"#/components/schemas/link_action"},{"$ref":"#/components/schemas/reply_action"},{"$ref":"#/components/schemas/call_phone_number_action"}]},"maxItems":9}}}}},"whatsapp_multi_product":{"type":"object","additionalProperties":false,"required":["type","whatsappMultiProduct"],"description":"A product list block used for commerce product templates.","properties":{"id":{"type":"string"},"type":{"type":"string","enum":["whatsapp-multi-product"]},"reference":{"type":"string"},"role":{"type":"string"},"hidden":{"type":"boolean"},"whatsappMultiProduct":{"type":"object","additionalProperties":false,"required":["header","body","action"],"properties":{"header":{"$ref":"#/components/schemas/text"},"body":{"$ref":"#/components/schemas/text"},"footer":{"$ref":"#/components/schemas/text"},"action":{"$ref":"#/components/schemas/multi_product_action"}}}}},"whatsapp_carousel":{"type":"object","additionalProperties":false,"required":["type","whatsappCarousel"],"properties":{"id":{"type":"string"},"type":{"type":"string","enum":["whatsapp-carousel"]},"reference":{"type":"string"},"role":{"type":"string"},"hidden":{"type":"boolean"},"whatsappCarousel":{"type":"object","additionalProperties":false,"required":["body"],"properties":{"body":{"$ref":"#/components/schemas/text"},"cardsType":{"type":"string","enum":["static","dynamic","hybrid"],"description":"Type of cards - static (all inline), dynamic (all from parameter), or hybrid (static + dynamic appended). Defaults to static."},"cardsParameterKey":{"type":"string","description":"Parameter key for dynamic cards. Required when cardsType is dynamic or hybrid."},"cards":{"type":"array","minItems":0,"maxItems":10,"items":{"$ref":"#/components/schemas/whatsapp_carousel_card"},"description":"Static card definitions. For hybrid mode, these are first cards followed by dynamic cards."}}}}},"whatsapp_carousel_card":{"type":"object","additionalProperties":false,"required":["type","whatsappCarouselCard"],"properties":{"id":{"type":"string"},"type":{"type":"string","enum":["whatsapp-carousel-card"]},"reference":{"type":"string"},"role":{"type":"string"},"hidden":{"type":"boolean"},"whatsappCarouselCard":{"type":"object","additionalProperties":false,"required":["header","body","actions"],"properties":{"header":{"oneOf":[{"$ref":"#/components/schemas/image"},{"$ref":"#/components/schemas/file"}]},"body":{"$ref":"#/components/schemas/text"},"actions":{"type":"array","items":{"anyOf":[{"$ref":"#/components/schemas/link_action"},{"$ref":"#/components/schemas/reply_action"},{"$ref":"#/components/schemas/call_phone_number_action"}]},"minItems":1,"maxItems":2,"description":"Approved templates support up to 2 actions per card (link-action, reply-action, or call-phone-number-action). Session carousels only support one CTA URL button per card (enforced at runtime)."}}}}},"whatsapp_limited_time_offer":{"type":"object","additionalProperties":false,"required":["type","whatsappLimitedTimeOffer"],"description":"A limited-time offer block to display messages with expiration date, countdown and promotional codes.","properties":{"id":{"type":"string"},"type":{"type":"string","enum":["whatsapp-limited-time-offer"]},"reference":{"type":"string"},"role":{"type":"string"},"hidden":{"type":"boolean"},"whatsappLimitedTimeOffer":{"type":"object","additionalProperties":false,"required":["body","limitedTimeOffer","linkAction"],"properties":{"header":{"oneOf":[{"$ref":"#/components/schemas/image"},{"$ref":"#/components/schemas/file"}]},"body":{"$ref":"#/components/schemas/text"},"limitedTimeOffer":{"$ref":"#/components/schemas/limited_time_offer"},"couponAction":{"$ref":"#/components/schemas/copy_code_action"},"linkAction":{"$ref":"#/components/schemas/link_action"}}}}},"whatsapp_flow_action":{"type":"object","additionalProperties":false,"required":["type","whatsappFlowAction"],"properties":{"id":{"type":"string"},"type":{"type":"string","enum":["whatsapp-flow-action"]},"reference":{"type":"string"},"role":{"type":"string"},"hidden":{"type":"boolean"},"whatsappFlowAction":{"oneOf":[{"type":"object","additionalProperties":false,"required":["id","label","actionType"],"properties":{"token":{"type":"string"},"id":{"type":"string"},"label":{"type":"string"},"actionType":{"type":"string","enum":["navigate"]},"actionPayload":{"type":"object","additionalProperties":false,"properties":{"screen":{"type":"string"},"data":{"type":"object","nullable":true,"additionalProperties":true}}}}},{"type":"object","additionalProperties":false,"required":["id","label","actionType"],"properties":{"token":{"type":"string"},"id":{"type":"string"},"label":{"type":"string"},"actionType":{"type":"string","enum":["data_exchange"]}}}]}}},"whatsapp_flow":{"type":"object","additionalProperties":false,"required":["type","whatsappFlow"],"description":"A product block used for commerce product templates.","properties":{"id":{"type":"string"},"type":{"type":"string","enum":["whatsapp-flow"]},"reference":{"type":"string"},"role":{"type":"string"},"hidden":{"type":"boolean"},"whatsappFlow":{"type":"object","additionalProperties":false,"required":["body","action"],"properties":{"header":{"oneOf":[{"$ref":"#/components/schemas/image"},{"$ref":"#/components/schemas/file"},{"$ref":"#/components/schemas/text"}]},"body":{"$ref":"#/components/schemas/text"},"footer":{"$ref":"#/components/schemas/text"},"action":{"$ref":"#/components/schemas/whatsapp_flow_action"}}}}},"push_notification_message":{"type":"object","additionalProperties":false,"required":["type","pushNotificationsMessage"],"description":"A product block used for commerce product templates.","properties":{"id":{"type":"string"},"type":{"type":"string","enum":["push-notifications-message"]},"reference":{"type":"string"},"role":{"type":"string"},"hidden":{"type":"boolean"},"pushNotificationsMessage":{"type":"object","required":["v1"],"properties":{"v1":{"type":"object","additionalProperties":false,"required":["tapAction"],"properties":{"title":{"type":"string"},"body":{"type":"string"},"subtitle":{"type":"string"},"tapAction":{"$ref":"#/components/schemas/push_notification_action"},"imageUrl":{"type":"string"},"buttons":{"type":"array","items":{"$ref":"#/components/schemas/push_notification_action"}},"soundEnabled":{"type":"boolean"},"badgeCount":{"type":"integer","minimum":0},"displayPriority":{"type":"string","enum":["LOW","DEFAULT","HIGH"]},"customPayload":{"type":"string"},"customConfiguration":{"type":"object","additionalProperties":false,"properties":{"apns":{"type":"object","properties":{"title":{"type":"string"},"body":{"type":"string"},"subTitle":{"type":"string"},"tapAction":{"$ref":"#/components/schemas/push_notification_action"},"imageUrl":{"type":"string"},"buttons":{"type":"array","items":{"$ref":"#/components/schemas/push_notification_action"}},"soundEnabled":{"type":"boolean"},"badgeCount":{"type":"integer","minimum":0},"displayPriority":{"type":"string","enum":["LOW","DEFAULT","HIGH"]},"customPayload":{"type":"string"},"customCategory":{"type":"string"}}},"firebase":{"type":"object","properties":{"title":{"type":"string"},"body":{"type":"string"},"subTitle":{"type":"string"},"tapAction":{"$ref":"#/components/schemas/push_notification_action"},"imageUrl":{"type":"string"},"buttons":{"type":"array","items":{"$ref":"#/components/schemas/push_notification_action"}},"soundEnabled":{"type":"boolean"},"badgeCount":{"type":"integer","minimum":0},"displayPriority":{"type":"string","enum":["LOW","DEFAULT","HIGH"]},"customPayload":{"type":"string"}}},"web":{"type":"object","properties":{"title":{"type":"string"},"body":{"type":"string"},"subTitle":{"type":"string"},"tapAction":{"$ref":"#/components/schemas/push_notification_action"},"imageUrl":{"type":"string"},"buttons":{"type":"array","items":{"$ref":"#/components/schemas/push_notification_action"}},"soundEnabled":{"type":"boolean"},"badgeCount":{"type":"integer","minimum":0},"displayPriority":{"type":"string","enum":["LOW","DEFAULT","HIGH"]},"customPayload":{"type":"string"}}}}}}}}}}},"push_notification_action":{"type":"object","additionalProperties":false,"required":["type"],"properties":{"type":{"type":"string","enum":["OPEN_APP","URL","DEEP_LINK"]},"uri":{"type":"string","format":"uri"},"title":{"type":"string"},"identifier":{"type":"string"}}},"rcs_basic_text":{"type":"object","additionalProperties":false,"required":["type","rcsBasicText"],"description":"Block structure for RCS Basic Text. Supports up to 160 UTF-8 characters.","properties":{"id":{"type":"string"},"type":{"type":"string","enum":["rcs-basic-text"]},"reference":{"type":"string"},"role":{"type":"string"},"hidden":{"type":"boolean"},"rcsBasicText":{"type":"object","additionalProperties":false,"required":["text"],"properties":{"text":{"type":"string"}}}}},"rcs_rich_card":{"type":"object","additionalProperties":false,"required":["type"],"description":"A product block used for RCS Rich cards.","properties":{"id":{"type":"string"},"type":{"type":"string","enum":["rcs-rich-card"]},"reference":{"type":"string"},"role":{"type":"string"},"hidden":{"type":"boolean"},"rcsRichCard":{"type":"object","additionalProperties":false,"required":["orientation","thumbnailImageAlignment","card"],"properties":{"orientation":{"type":"string","enum":["vertical","horizontal"]},"thumbnailImageAlignment":{"type":"string","enum":["left","right"]},"card":{"$ref":"#/components/schemas/rcs_card"},"suggestions":{"type":"array","maxItems":11,"items":{"$ref":"#/components/schemas/rcs_suggestion"}}}}}},"rcs_card":{"type":"object","additionalProperties":false,"description":"A a RCS card used in RCS Carousel or as a standalone card","properties":{"id":{"type":"string"},"title":{"type":"string"},"description":{"type":"string"},"media":{"$ref":"#/components/schemas/rcs_media"},"suggestions":{"type":"array","maxItems":4,"items":{"$ref":"#/components/schemas/rcs_suggestion"}}}},"rcs_media":{"type":"object","additionalProperties":false,"description":"A media for use with RCS messages","required":["height","fileUrl"],"properties":{"height":{"type":"string","enum":["short","medium","tall"]},"fileUrl":{"type":"string"},"thumbnailUrl":{"type":"string","nullable":true}}},"rcs_suggestion":{"type":"object","additionalProperties":false,"description":"A suggestion for use with RCS messages","required":["type"],"properties":{"id":{"type":"string"},"type":{"type":"string","enum":["reply","action"]},"reply":{"type":"object","additionalProperties":false,"required":["text","postbackData"],"properties":{"text":{"type":"string","maxLength":25},"postbackData":{"type":"string","minLength":1}}},"action":{"type":"object","additionalProperties":false,"required":["type","text","postbackData"],"properties":{"type":{"type":"string","enum":["openUrl","dial","createCalendarEvent","viewLocation","shareLocation"]},"text":{"type":"string","maxLength":25,"minLength":1},"postbackData":{"type":"string","minLength":1},"fallbackUrl":{"type":"string"},"dialAction":{"$ref":"#/components/schemas/rcs_suggestion_action_dial"},"openUrlAction":{"$ref":"#/components/schemas/rcs_suggestion_action_open_url"},"createCalendarEventAction":{"$ref":"#/components/schemas/rcs_suggestion_action_calendar"},"viewLocationAction":{"$ref":"#/components/schemas/rcs_suggestion_action_view_location"},"shareLocationAction":{"$ref":"#/components/schemas/rcs_suggestion_action_share_location"}},"oneOf":[{"required":["dialAction"]},{"required":["openUrlAction"]},{"required":["createCalendarEventAction"]},{"required":["viewLocationAction"]},{"required":["shareLocationAction"]}]}}},"rcs_suggestion_action_dial":{"type":"object","additionalProperties":false,"required":["phoneNumber"],"properties":{"phoneNumber":{"type":"string","description":"The phone number in E.164 format, for example, +12223334444"}}},"rcs_suggestion_action_open_url":{"type":"object","additionalProperties":false,"required":["url"],"properties":{"url":{"type":"string","description":"URL"},"application":{"type":"string","enum":["browser","webview"],"description":"URL open application"},"webviewViewMode":{"type":"string","enum":["full","half","tall"],"description":"View mode for webview"},"description":{"type":"string","description":"Accessibility description for webview"}}},"rcs_suggestion_action_calendar":{"type":"object","additionalProperties":false,"required":["title","description","start","end"],"properties":{"title":{"type":"string"},"description":{"type":"string"},"start":{"type":"string","format":"date-time"},"end":{"type":"string","format":"date-time"}}},"rcs_suggestion_action_view_location":{"type":"object","additionalProperties":false,"properties":{"label":{"type":"string","description":"(Optional) The label of the pin dropped at latLong."},"query":{"type":"string","description":"(Optional) The query to search for."},"latLong":{"type":"object","description":"(Optional, only supported on Android Messages clients) Rather than specify a latLong (and optionally, a label), the agent can instead specify a query string.","additionalProperties":false,"required":["latitude","longitude"],"properties":{"latitude":{"type":"string","description":"The latitude of the location."},"longitude":{"type":"string","description":"The longitude of the location."}}}}},"rcs_suggestion_action_share_location":{"type":"object","additionalProperties":false},"rcs_carousel":{"type":"object","additionalProperties":false,"required":["type"],"description":"A product block used for RCS carousel.","properties":{"id":{"type":"string"},"type":{"type":"string","enum":["rcs-carousel"]},"reference":{"type":"string"},"role":{"type":"string"},"hidden":{"type":"boolean"},"rcsCarousel":{"type":"object","additionalProperties":false,"required":["cardWidth","cards"],"properties":{"cardWidth":{"type":"string","enum":["small","medium"]},"cards":{"type":"array","items":{"$ref":"#/components/schemas/rcs_card"}},"suggestions":{"type":"array","maxItems":11,"items":{"$ref":"#/components/schemas/rcs_suggestion"}}}}}},"rcs_rich_message":{"type":"object","additionalProperties":false,"required":["type"],"description":"A block used for a combination of text, media and suggestions.","properties":{"id":{"type":"string"},"type":{"type":"string","enum":["rcs-rich-message"]},"reference":{"type":"string"},"role":{"type":"string"},"hidden":{"type":"boolean"},"rcsRichMessage":{"type":"object","additionalProperties":false,"anyOf":[{"required":["text"]},{"required":["media"]}],"properties":{"text":{"type":"string","nullable":true,"minLength":1},"media":{"$ref":"#/components/schemas/rcs_media"},"suggestions":{"type":"array","maxItems":11,"items":{"$ref":"#/components/schemas/rcs_suggestion"}}}}}},"app_inbox_message":{"type":"object","additionalProperties":false,"required":["type","appInboxMessage"],"description":"A product block used for commerce product templates.","properties":{"id":{"type":"string"},"type":{"type":"string","enum":["app-inbox-message"]},"reference":{"type":"string"},"role":{"type":"string"},"hidden":{"type":"boolean"},"appInboxMessage":{"type":"object","required":["v1"],"properties":{"v1":{"type":"object","additionalProperties":false,"properties":{"type":{"type":"string"},"basicContent":{"type":"object","required":["title","body"],"properties":{"title":{"type":"string","minLength":1,"maxLength":65},"body":{"type":"string","minLength":1,"maxLength":240}}}}}}}}},"Style":{"oneOf":[{"$ref":"#/components/schemas/ValueString"},{"$ref":"#/components/schemas/ValueStringArray"},{"$ref":"#/components/schemas/ValueConfigurationPair"},{"$ref":"#/components/schemas/ValueConfigurationPairArray"},{"$ref":"#/components/schemas/ValueBoolean"},{"$ref":"#/components/schemas/ValueBooleanArray"},{"$ref":"#/components/schemas/ValueFloat"},{"$ref":"#/components/schemas/ValueFloatArray"},{"$ref":"#/components/schemas/ValueInteger"},{"$ref":"#/components/schemas/ValueIntegerArray"}]},"ValueString":{"type":"object","additionalProperties":false,"required":["key","valueString"],"properties":{"key":{"type":"string"},"valueString":{"type":"string"},"isDefault":{"type":"boolean","nullable":true}}},"ValueStringArray":{"type":"object","additionalProperties":false,"required":["key","valueStringArray"],"properties":{"key":{"type":"string"},"valueStringArray":{"type":"array","items":{"type":"string"}},"isDefault":{"type":"boolean","nullable":true}}},"ValueConfigurationPair":{"type":"object","additionalProperties":false,"required":["key","valueConfigurationPair"],"properties":{"key":{"type":"string"},"valueConfigurationPair":{"type":"object","additionalProperties":true},"isDefault":{"type":"boolean","nullable":true}}},"ValueConfigurationPairArray":{"type":"object","additionalProperties":false,"required":["key","valueConfigurationPairArray"],"properties":{"key":{"type":"string"},"valueConfigurationPairArray":{"type":"array","items":{"type":"object","additionalProperties":true}},"isDefault":{"type":"boolean","nullable":true}}},"ValueBoolean":{"type":"object","additionalProperties":false,"required":["key","valueBoolean"],"properties":{"key":{"type":"string"},"valueBoolean":{"type":"boolean"},"isDefault":{"type":"boolean","nullable":true}}},"ValueBooleanArray":{"type":"object","additionalProperties":false,"required":["key","valueBooleanArray"],"properties":{"key":{"type":"string"},"valueBooleanArray":{"type":"array","items":{"type":"boolean"}},"isDefault":{"type":"boolean","nullable":true}}},"ValueFloat":{"type":"object","additionalProperties":false,"required":["key","valueFloat"],"properties":{"key":{"type":"string"},"floatValue":{"type":"number","format":"float"},"isDefault":{"type":"boolean","nullable":true}}},"ValueFloatArray":{"type":"object","additionalProperties":false,"required":["key","valueFloatArray"],"properties":{"key":{"type":"string"},"floatValueArray":{"type":"array","items":{"type":"number","format":"float"}},"isDefault":{"type":"boolean","nullable":true}}},"ValueInteger":{"type":"object","additionalProperties":false,"required":["key","valueInteger"],"properties":{"key":{"type":"string"},"valueInteger":{"type":"number"},"isDefault":{"type":"boolean","nullable":true}}},"ValueIntegerArray":{"type":"object","additionalProperties":false,"required":["key","valueIntegerArray"],"properties":{"key":{"type":"string"},"valueIntegerArray":{"type":"array","items":{"type":"number"}},"isDefault":{"type":"boolean","nullable":true}}},"Parameter-2":{"type":"object","additionalProperties":false,"properties":{"type":{"type":"string","enum":["string","systemVariable","sectionList","timeslotList","productList","productSections","shippingMethodList","whatsappProductSections","lineItemList","whatsappProductItems","shortLink","carouselCards","appleFormPageItems"]},"sourceUrl":{"$ref":"#/components/schemas/SourceUrl"},"key":{"type":"string"},"value":{"oneOf":[{"type":"string"},{"type":"object","additionalProperties":false,"properties":{"sections":{"$ref":"#/components/schemas/sections"}}},{"type":"object","additionalProperties":false,"properties":{"timeslots":{"$ref":"#/components/schemas/timeslots"}}},{"type":"object","additionalProperties":false,"properties":{"products":{"type":"array","items":{"$ref":"#/components/schemas/product"}}}},{"type":"object","additionalProperties":false,"properties":{"productSections":{"$ref":"#/components/schemas/product_sections_object"}}},{"type":"object","additionalProperties":false,"properties":{"shippingMethods":{"$ref":"#/components/schemas/apple_shipping_methods"}}},{"type":"object","additionalProperties":false,"properties":{"sections":{"type":"array","items":{"$ref":"#/components/schemas/whatsapp_product_section"}}}},{"type":"object","additionalProperties":false,"properties":{"lineItems":{"$ref":"#/components/schemas/apple_line_items"}}},{"type":"object","additionalProperties":false,"properties":{"products":{"type":"array","items":{"$ref":"#/components/schemas/whatsapp_product_item"}}}},{"type":"object","additionalProperties":false,"properties":{"cards":{"type":"array","items":{"$ref":"#/components/schemas/whatsapp_carousel_card"}}}},{"type":"object","additionalProperties":false,"properties":{"items":{"$ref":"#/components/schemas/apple_form_page_items"}}}]}}},"SourceUrl":{"type":"object","properties":{"fullyReplaced":{"type":"boolean"},"value":{"type":"string"}},"required":["fullyReplaced","value"]},"apple_line_items":{"type":"array","nullable":true,"items":{"$ref":"#/components/schemas/apple_line_item"}},"apple_form_page_items":{"type":"array","items":{"type":"object","additionalProperties":false,"required":["identifier","title","value"],"properties":{"identifier":{"type":"string","description":"Unique identifier for the item."},"title":{"type":"string","description":"Display label shown to the user."},"value":{"type":"string","description":"Value submitted when the item is selected."},"imageUrl":{"type":"string","nullable":true,"description":"Optional image URL for the item."},"nextPageIdentifier":{"type":"string","nullable":true,"description":"Identifier of the next page to navigate to when this item is selected."}}}},"ShortLinks":{"type":"object","properties":{"enabled":{"type":"boolean"},"domain":{"type":"string"}},"required":["Enabled","Domain"]},"LocaleBCP47":{"type":"string","format":"locale-bcp47"},"MessageBodyResponse":{"type":"object","additionalProperties":false,"properties":{"validationErrors":{"type":"object","additionalProperties":{"type":"array","items":{"type":"string"}}},"type":{"type":"string","enum":["body","blocks"]},"body":{"$ref":"#/components/schemas/channels.messages.body.body"},"blocks":{"type":"array","nullable":true,"items":{"$ref":"#/components/schemas/block"}},"styles":{"type":"array","nullable":true,"items":{"$ref":"#/components/schemas/Style"}}}},"channels.messages.body.body":{"allOf":[{"properties":{"type":{"enum":["text","html","image","gif","file","location","carousel","list","section","authentication","action"],"type":"string"}},"required":["type"],"type":"object"},{"discriminator":{"mapping":{"action":"#/components/schemas/channels.messages.body.body__action","authentication":"#/components/schemas/channels.messages.body.body__authentication","carousel":"#/components/schemas/channels.messages.body.body__carousel","file":"#/components/schemas/channels.messages.body.body__file","gif":"#/components/schemas/channels.messages.body.body__gif","html":"#/components/schemas/channels.messages.body.body__html","image":"#/components/schemas/channels.messages.body.body__image","list":"#/components/schemas/channels.messages.body.body__list","location":"#/components/schemas/channels.messages.body.body__location","section":"#/components/schemas/channels.messages.body.body__section","text":"#/components/schemas/channels.messages.body.body__text"},"propertyName":"type"},"oneOf":[{"$ref":"#/components/schemas/channels.messages.body.body__text"},{"$ref":"#/components/schemas/channels.messages.body.body__html"},{"$ref":"#/components/schemas/channels.messages.body.body__image"},{"$ref":"#/components/schemas/channels.messages.body.body__gif"},{"$ref":"#/components/schemas/channels.messages.body.body__file"},{"$ref":"#/components/schemas/channels.messages.body.body__location"},{"$ref":"#/components/schemas/channels.messages.body.body__carousel"},{"$ref":"#/components/schemas/channels.messages.body.body__list"},{"$ref":"#/components/schemas/channels.messages.body.body__section"},{"$ref":"#/components/schemas/channels.messages.body.body__authentication"},{"$ref":"#/components/schemas/channels.messages.body.body__action"}]}],"title":"Message Body"},"channels.messages.body.body__text":{"properties":{"text":{"$ref":"#/components/schemas/channels.messages.body.text"},"type":{"enum":["text"],"type":"string"}},"required":["text","type"],"type":"object"},"channels.messages.body.text":{"properties":{"actions":{"items":{"$ref":"#/components/schemas/channels.messages.actions.action"},"type":"array"},"attachments":{"items":{"$ref":"#/components/schemas/channels.messages.body.text_attachment"},"type":"array"},"metadata":{"$ref":"#/components/schemas/channels.messages.metadata.text"},"text":{"type":"string"}},"required":["text"],"type":"object"},"channels.messages.actions.action":{"allOf":[{"properties":{"type":{"enum":["link","reply","locationRequest","buy","postback"],"type":"string"}},"type":"object"},{"discriminator":{"mapping":{"buy":"#/components/schemas/channels.messages.actions.action__buy","link":"#/components/schemas/channels.messages.actions.action__link","locationRequest":"#/components/schemas/channels.messages.actions.action__locationRequest","postback":"#/components/schemas/channels.messages.actions.action__postback","reply":"#/components/schemas/channels.messages.actions.action__reply"},"propertyName":"type"},"oneOf":[{"$ref":"#/components/schemas/channels.messages.actions.action__link"},{"$ref":"#/components/schemas/channels.messages.actions.action__reply"},{"$ref":"#/components/schemas/channels.messages.actions.action__locationRequest"},{"$ref":"#/components/schemas/channels.messages.actions.action__buy"},{"$ref":"#/components/schemas/channels.messages.actions.action__postback"}]}]},"channels.messages.actions.action__link":{"properties":{"link":{"$ref":"#/components/schemas/channels.messages.actions.link"},"type":{"enum":["link"],"type":"string"}},"required":["link","type"],"type":"object"},"channels.messages.actions.link":{"properties":{"metadata":{"$ref":"#/components/schemas/channels.messages.metadata.action_link"},"text":{"type":"string"},"url":{"type":"string"}},"required":["text","url"],"type":"object"},"channels.messages.metadata.action_link":{"properties":{"description":{"$ref":"#/components/schemas/channels.messages.metadata.action_description"}},"type":"object"},"channels.messages.metadata.action_description":{"properties":{"label":{"type":"string"}},"required":["label"],"type":"object"},"channels.messages.actions.action__reply":{"properties":{"reply":{"$ref":"#/components/schemas/channels.messages.actions.reply"},"type":{"enum":["reply"],"type":"string"}},"required":["reply","type"],"type":"object"},"channels.messages.actions.reply":{"properties":{"imageUrl":{"type":"string"},"metadata":{"$ref":"#/components/schemas/channels.messages.metadata.action_reply"},"text":{"type":"string"}},"required":["text"],"type":"object"},"channels.messages.metadata.action_reply":{"properties":{"description":{"$ref":"#/components/schemas/channels.messages.metadata.action_description"}},"type":"object"},"channels.messages.actions.action__locationRequest":{"properties":{"locationRequest":{"$ref":"#/components/schemas/channels.messages.actions.location_request"},"type":{"enum":["locationRequest"],"type":"string"}},"required":["locationRequest","type"],"type":"object"},"channels.messages.actions.location_request":{"properties":{"text":{"type":"string"}},"required":["text"],"type":"object"},"channels.messages.actions.action__buy":{"properties":{"buy":{"$ref":"#/components/schemas/channels.messages.actions.buy"},"type":{"enum":["buy"],"type":"string"}},"required":["buy","type"],"type":"object"},"channels.messages.actions.buy":{"properties":{"amountCents":{"format":"int64","type":"integer"},"currency":{"type":"string"},"text":{"type":"string"}},"required":["text","amountCents","currency"],"type":"object"},"channels.messages.actions.action__postback":{"properties":{"postback":{"$ref":"#/components/schemas/channels.messages.actions.postback"},"type":{"enum":["postback"],"type":"string"}},"required":["postback","type"],"type":"object"},"channels.messages.actions.postback":{"properties":{"handshake":{"$ref":"#/components/schemas/channels.messages.actions.postback_handshake"},"imageUrl":{"type":"string"},"metadata":{"$ref":"#/components/schemas/channels.messages.metadata.action_postback"},"otpType":{"type":"string"},"payload":{"type":"string"},"text":{"type":"string"}},"required":["text","payload"],"type":"object"},"channels.messages.actions.postback_handshake":{"properties":{"packageName":{"type":"string"},"signatureHash":{"type":"string"},"supportedApps":{"items":{"$ref":"#/components/schemas/channels.messages.actions.postback_handshake_supported_app"},"type":"array"},"text":{"type":"string"},"zeroTapTermsAccepted":{"type":"boolean"}},"required":["text","packageName","signatureHash","zeroTapTermsAccepted"],"type":"object"},"channels.messages.actions.postback_handshake_supported_app":{"properties":{"packageName":{"type":"string"},"signatureHash":{"type":"string"}},"required":["packageName","signatureHash"],"type":"object"},"channels.messages.metadata.action_postback":{"properties":{"description":{"$ref":"#/components/schemas/channels.messages.metadata.action_description"}},"type":"object"},"channels.messages.body.text_attachment":{"properties":{"content":{"type":"string"},"contentId":{"type":"string"},"contentType":{"type":"string"},"filename":{"type":"string"},"inline":{"type":"boolean"},"mediaUrl":{"type":"string"}},"required":["mediaUrl","filename"],"type":"object"},"channels.messages.metadata.text":{"properties":{"apple":{"$ref":"#/components/schemas/channels.messages.metadata.text_apple"},"headers":{"additionalProperties":{"type":"string"},"type":"object"},"line":{"$ref":"#/components/schemas/channels.messages.metadata.text_line"},"paymentDetails":{"$ref":"#/components/schemas/channels.messages.metadata.text_payment_details"},"subject":{"type":"string"},"telegram":{"$ref":"#/components/schemas/channels.messages.metadata.text_telegram"},"whatsapp":{"$ref":"#/components/schemas/channels.messages.metadata.text_whatsapp"}},"type":"object"},"channels.messages.metadata.text_apple":{"properties":{"appClipPreview":{"type":"boolean"},"appClipRegion":{"type":"string"},"summaryText":{"type":"string"}},"type":"object"},"channels.messages.metadata.text_line":{"properties":{"emoji":{"$ref":"#/components/schemas/channels.messages.metadata.text_line_emoji"}},"type":"object"},"channels.messages.metadata.text_line_emoji":{"properties":{"items":{"items":{"$ref":"#/components/schemas/channels.messages.metadata.text_line_emoji_item"},"type":"array"}},"type":"object"},"channels.messages.metadata.text_line_emoji_item":{"properties":{"emojiId":{"type":"string"},"index":{"format":"uint32","type":"integer"},"length":{"format":"uint32","type":"integer"},"productId":{"type":"string"}},"required":["index","productId","emojiId"],"type":"object"},"channels.messages.metadata.text_payment_details":{"properties":{"amount":{"type":"string"},"currency":{"type":"string"},"sessionIdentifier":{"type":"string"},"state":{"type":"string"}},"required":["amount","state","currency"],"type":"object"},"channels.messages.metadata.text_telegram":{"properties":{"parseMode":{"type":"string"}},"type":"object"},"channels.messages.metadata.text_whatsapp":{"properties":{"callPermissionExpiration":{"format":"date-time","type":"string"},"callPermissionResponse":{"$ref":"#/components/schemas/channels.messages.metadata.text_whatsapp_call_permission_response"},"previewUrl":{"type":"boolean"}},"required":["previewUrl"],"type":"object"},"channels.messages.metadata.text_whatsapp_call_permission_response":{"enum":["accept","reject"],"type":"string"},"channels.messages.body.body__html":{"properties":{"html":{"$ref":"#/components/schemas/channels.messages.body.html"},"type":{"enum":["html"],"type":"string"}},"required":["html","type"],"type":"object"},"channels.messages.body.html":{"properties":{"actions":{"items":{"$ref":"#/components/schemas/channels.messages.actions.action"},"type":"array"},"attachments":{"items":{"$ref":"#/components/schemas/channels.messages.body.html_attachment"},"type":"array"},"html":{"type":"string"},"metadata":{"$ref":"#/components/schemas/channels.messages.metadata.html"},"text":{"type":"string"}},"type":"object"},"channels.messages.body.html_attachment":{"properties":{"content":{"type":"string"},"contentId":{"type":"string"},"contentType":{"type":"string"},"filename":{"type":"string"},"inline":{"type":"boolean"},"mediaUrl":{"type":"string"}},"required":["filename"],"type":"object"},"channels.messages.metadata.html":{"properties":{"clickTracking":{"type":"boolean"},"from":{"$ref":"#/components/schemas/channels.messages.metadata.email_from"},"headers":{"additionalProperties":{"type":"string"},"type":"object"},"initialOpenTracking":{"type":"boolean"},"openTracking":{"type":"boolean"},"subject":{"type":"string"}},"type":"object"},"channels.messages.metadata.email_from":{"properties":{"displayName":{"type":"string"},"username":{"type":"string"}},"type":"object"},"channels.messages.body.body__image":{"properties":{"image":{"$ref":"#/components/schemas/channels.messages.body.images"},"type":{"enum":["image"],"type":"string"}},"required":["image","type"],"type":"object"},"channels.messages.body.images":{"properties":{"actions":{"items":{"$ref":"#/components/schemas/channels.messages.actions.action"},"type":"array"},"images":{"items":{"$ref":"#/components/schemas/channels.messages.body.image"},"type":"array"},"metadata":{"$ref":"#/components/schemas/channels.messages.metadata.images"},"text":{"type":"string"}},"required":["images"],"type":"object"},"channels.messages.body.image":{"properties":{"altText":{"type":"string"},"mediaPreviewUrl":{"type":"string"},"mediaUrl":{"type":"string"}},"required":["mediaUrl"],"type":"object"},"channels.messages.metadata.images":{"properties":{"fallbackText":{"type":"string"},"storyType":{"$ref":"#/components/schemas/channels.messages.metadata.story_type"},"subject":{"type":"string"},"telegram":{"$ref":"#/components/schemas/channels.messages.metadata.images_telegram"}},"type":"object"},"channels.messages.metadata.story_type":{"enum":["mention","reply"],"type":"string"},"channels.messages.metadata.images_telegram":{"properties":{"parseMode":{"type":"string"}},"type":"object"},"channels.messages.body.body__gif":{"properties":{"gif":{"$ref":"#/components/schemas/channels.messages.body.gif"},"type":{"enum":["gif"],"type":"string"}},"required":["gif","type"],"type":"object"},"channels.messages.body.gif":{"properties":{"actions":{"items":{"$ref":"#/components/schemas/channels.messages.actions.action"},"type":"array"},"altText":{"type":"string"},"mediaUrl":{"type":"string"},"metadata":{"$ref":"#/components/schemas/channels.messages.metadata.gif"},"text":{"type":"string"}},"required":["mediaUrl"],"type":"object"},"channels.messages.metadata.gif":{"properties":{"telegram":{"$ref":"#/components/schemas/channels.messages.metadata.gif_telegram"}},"type":"object"},"channels.messages.metadata.gif_telegram":{"properties":{"parseMode":{"type":"string"}},"type":"object"},"channels.messages.body.body__file":{"properties":{"file":{"$ref":"#/components/schemas/channels.messages.body.files"},"type":{"enum":["file"],"type":"string"}},"required":["file","type"],"type":"object"},"channels.messages.body.files":{"properties":{"actions":{"items":{"$ref":"#/components/schemas/channels.messages.actions.action"},"type":"array"},"files":{"items":{"$ref":"#/components/schemas/channels.messages.body.file"},"type":"array"},"metadata":{"$ref":"#/components/schemas/channels.messages.metadata.files"},"text":{"type":"string"}},"required":["files"],"type":"object"},"channels.messages.body.file":{"properties":{"altText":{"type":"string"},"contentType":{"type":"string"},"filename":{"type":"string"},"mediaUrl":{"type":"string"},"metadata":{"$ref":"#/components/schemas/channels.messages.metadata.file"}},"required":["contentType","mediaUrl"],"type":"object"},"channels.messages.metadata.file":{"properties":{"isAnimated":{"type":"boolean"}},"type":"object"},"channels.messages.metadata.files":{"properties":{"fallbackText":{"type":"string"},"storyType":{"$ref":"#/components/schemas/channels.messages.metadata.story_type"},"subject":{"type":"string"},"telegram":{"$ref":"#/components/schemas/channels.messages.metadata.files_telegram"}},"type":"object"},"channels.messages.metadata.files_telegram":{"properties":{"parseMode":{"type":"string"}},"type":"object"},"channels.messages.body.body__location":{"properties":{"location":{"$ref":"#/components/schemas/channels.messages.body.location"},"type":{"enum":["location"],"type":"string"}},"required":["location","type"],"type":"object"},"channels.messages.body.location":{"properties":{"coordinates":{"$ref":"#/components/schemas/channels.messages.body.location_coordinates"},"location":{"$ref":"#/components/schemas/channels.messages.body.location_location"}},"required":["coordinates","location"],"type":"object"},"channels.messages.body.location_coordinates":{"properties":{"latitude":{"format":"double","type":"number"},"longitude":{"format":"double","type":"number"}},"required":["latitude","longitude"],"type":"object"},"channels.messages.body.location_location":{"properties":{"address":{"type":"string"},"label":{"type":"string"}},"required":["address","label"],"type":"object"},"channels.messages.body.body__carousel":{"properties":{"carousel":{"$ref":"#/components/schemas/channels.messages.body.carousel"},"type":{"enum":["carousel"],"type":"string"}},"required":["carousel","type"],"type":"object"},"channels.messages.body.carousel":{"properties":{"items":{"items":{"$ref":"#/components/schemas/channels.messages.body.item"},"type":"array"},"text":{"type":"string"}},"type":"object"},"channels.messages.body.item":{"properties":{"actions":{"items":{"$ref":"#/components/schemas/channels.messages.actions.action"},"type":"array"},"altText":{"type":"string"},"description":{"type":"string"},"mediaUrl":{"type":"string"},"size":{"format":"int64","type":"integer"},"title":{"type":"string"}},"required":["title"],"type":"object"},"channels.messages.body.body__list":{"properties":{"list":{"$ref":"#/components/schemas/channels.messages.body.list"},"type":{"enum":["list"],"type":"string"}},"required":["list","type"],"type":"object"},"channels.messages.body.list":{"properties":{"actions":{"items":{"$ref":"#/components/schemas/channels.messages.actions.action"},"type":"array"},"altText":{"type":"string"},"items":{"items":{"$ref":"#/components/schemas/channels.messages.body.item"},"type":"array"},"metadata":{"$ref":"#/components/schemas/channels.messages.metadata.list"},"text":{"type":"string"},"title":{"type":"string"}},"type":"object"},"channels.messages.metadata.list":{"properties":{"button":{"$ref":"#/components/schemas/channels.messages.metadata.action_list_button"},"replyMessage":{"$ref":"#/components/schemas/channels.messages.metadata.action_list_reply_message"}},"type":"object"},"channels.messages.metadata.action_list_button":{"properties":{"label":{"type":"string"}},"required":["label"],"type":"object"},"channels.messages.metadata.action_list_reply_message":{"properties":{"text":{"type":"string"},"title":{"type":"string"}},"required":["title","text"],"type":"object"},"channels.messages.body.body__section":{"properties":{"sec
[...]
